Loading...
Searching...
No Matches
casacore::VirtualTaQLColumn Class Reference
tables package (libcasa_tables) » DataMan_module

More...

`#include <VirtualTaQLColumn.h>`

## Public Member Functions

| VirtualTaQLColumn (const String &expr, const String &style=String())
| Construct it with the given TaQL expression.
| VirtualTaQLColumn (const Record &spec)
| Construct it with the given specification.
virtual | ~VirtualTaQLColumn ()
| Destructor is mandatory.
| VirtualTaQLColumn (const VirtualTaQLColumn &)=delete
| Copy is not needed and therefore forbidden.
VirtualTaQLColumn & | operator= (const VirtualTaQLColumn &)=delete
| Assignment is not needed and therefore forbidden.
virtual DataManager * | clone () const
| Clone the engine object.
virtual Record | dataManagerSpec () const
| Get the data manager specification.
virtual String | dataManagerType () const
| Return the type name of the engine.
const String & | expression () const
| Return the TaQL expression used.
virtual void | setShapeColumn (const IPosition &aShape)
| Set the shape of an array in the column.
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of a 'fixed length' string.
virtual int | dataType () const
| Functions to return column info.
virtual Bool | isWritable () const
| Test if data can be put into this column.
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
virtual IPosition | shape (rownr_t rownr)
| Get the shape of the item in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
Public Member Functions inherited from casacore::VirtualColumnEngine
| VirtualColumnEngine ()
| Create the object.
virtual | ~VirtualColumnEngine ()
| VirtualColumnEngine (const VirtualColumnEngine &)=delete
| The copy constructor cannot be used for this base class.
VirtualColumnEngine & | operator= (const VirtualColumnEngine &)=delete
| Assignment cannot be used for this base class.
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
virtual String | dataManagerName () const
| Return the name of the data manager.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties given in record fields.
virtual Bool | canReallocateColumns () const
| Tell if the data manager wants to reallocate the data manager column objects.
virtual DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual void | reopenRW ()
| Reopen the data manager for read/write access.
virtual Bool | canAddColumn () const
| Does the data manager allow to add columns?
virtual Bool | canRemoveColumn () const
| Does the data manager allow to delete columns?
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an (variable-shaped) array in the given row.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
virtual Bool | canChangeShape () const
| Can the data manager handle chaging the shape of an existing array?
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
virtual void | putScalarColumnV (const ArrayBase &dataPtr)
| Put all scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
virtual void | putArrayV (rownr_t rownr, const ArrayBase &data)
| Put the array value into the given row.
virtual void | getArrayColumnV (ArrayBase &data)
| Get all array values in the column.
virtual void | putArrayColumnV (const ArrayBase &data)
| Put all array values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &data)
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &data)
| Put some array values in the column.
virtual void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
| Get a section of the array in the given row.
virtual void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
| Put into a section of the array in the given row.
virtual void | getColumnSliceV (const Slicer &slicer, ArrayBase &data)
| Get a section of all arrays in the column.
virtual void | putColumnSliceV (const Slicer &slicer, const ArrayBase &data)
| Put into a section of all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
| Put into a section of some arrays in the column.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Static Public Member Functions

static String | className ()
| Return the name of the class.
static void | registerClass ()
| Register the class name and the static makeObject "constructor".
static DataManager * | makeObject (const String &dataManagerName, const Record &spec)
| Define the "constructor" to construct this engine when a table is read back.
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.

## Private Member Functions

virtual DataManagerColumn * | makeScalarColumn (const String &columnName, int dataType, const String &)
| Create the column object for the scalar column in this engine.
virtual DataManagerColumn * | makeIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create the column object for the indirect array column in this engine.
virtual void | create64 (rownr_t)
| Let the engine initialize the object for a new table.
virtual void | prepare ()
| Prepare compiles the expression.
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | getArrayV (rownr_t rownr, ArrayBase &arr)
| Get the array value in the given row.
void | getResult (rownr_t rownr)
| Get the array result into itsCurArray.
void | makeCurArray ()
| Make the result cache.
virtual void | getScalarColumnV (ArrayBase &arr)
| Get functions implemented by means of their DataManagerColumn::getXXBase counterparts, but optimized for constant expressions.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &arr)
| Get some scalar values in the column.
void | fillColumnCache ()
| Fill the ColumnCache object with a constant scalar value.
void | fillArray (ArrayBase &data)
| Fill an array with a constant scalar value.

## Private Attributes

int | itsDataType
Bool | itsIsArray
Bool | itsIsConst
Bool | itsTempWritable
String | itsColumnName
String | itsExpr
String | itsStyle
TableExprNode * | itsNode
IPosition | itsShape
uInt | itsMaxLen
union { |
Bool itsBool |
uChar itsuChar |
Short itsShort |
uShort itsuShort |
Int itsInt |
uInt itsuInt |
Int64 itsInt64 |
Float itsFloat |
Double itsDouble |
}; |
Complex | itsComplex
DComplex | itsDComplex
String | itsString
ArrayBase * | itsCurArray
rownr_t | itsCurRow

## Additional Inherited Members

Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
virtual Bool | hasMultiFileSupport () const
| Does the data manager support use of MultiFile?
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)

## Detailed Description

Virtual scalar column using TaQL

### Review Status

Reviewed By:
  GvD
Date Reviewed:
  2004/07/09

### Prerequisite

- VirtualScalarColumn

### Synopsis

VirtualTaQLColumn is a virtual column engine to define the contents of a column as a TaQL CALC expression in which possibly other columns are used. It is (of course) only possible to get data from the column; puts cannot be done. See note 199 for a description of TaQL. The TaQL style can be specified (such as 0- or 1-based indexing).
The expression result can be a scalar or array of the basic TaQL data types. The column data type has to be conformant with that TaQL type, thus a column of any integer type has to be used for an integer TaQL result.
Constant expressions are precalculated and cached making the retrieval of e.g. the full column much faster (factor 4).
A possible use for a virtual TaQL column is a column in a MeasurementSet containing a constant value. It could also be used for on-the-fly calculation of J2000 UVW-values or HADEC using an expression such as "derivedmscal.newuvw()"
Caution: One has to be careful with deleting columns; If in an existing table a TaQL expression uses a deleted column, the expression cannot be parsed anymore and the table cannot be opened anymore; In the future the Table System will be made more forgiving;

### Example

The following example creates a table with a few columns. One column is virtual and has a random value if Col3 is true. Otherwise it has value 0.

// Create the table description.
TableDesc td;
td.addColumn (ScalarColumnDesc<DComplex>("Col1"));
td.addColumn (ScalarColumnDesc<Int>("Col2"));
td.addColumn (ScalarColumnDesc<Bool>("Col3"));
td.addColumn (ScalarColumnDesc<Double>("ColVirt"));
// Now create a new table from the description.
SetupNewTable newTab("tmtest", td, Table::New);
// Define the expression of the virtual column and bind the column to it.
// The other columns are by default bound to StandardStMan.
VirtualTaQLColumn engine("iif(Col3,rand(),0)");
newTab.bindColumn("ColVirt", engine);
Table tab(newTab);
casacore::ScalarColumnDesc
Definition ScaColDesc.h:162
casacore::SetupNewTable
Create a new table - define shapes, data managers, etc.
Definition SetupNewTab.h:337
casacore::TableDesc
Definition TableDesc.h:189
casacore::TableDesc::addColumn
ColumnDesc & addColumn(const ColumnDesc &)
Add a column to the table description.
Definition TableDesc.h:568
casacore::Table
Definition Table.h:157
casacore::Table::New
@ New
create table
Definition Table.h:175
casacore::VirtualTaQLColumn::VirtualTaQLColumn
VirtualTaQLColumn(const String &expr, const String &style=String())
Construct it with the given TaQL expression.

Definition at line 95 of file VirtualTaQLColumn.h.

## Constructor & Destructor Documentation

## VirtualTaQLColumn() [1/3]

casacore::VirtualTaQLColumn::VirtualTaQLColumn | ( | const String & | expr,
|  | const String & | style = String() )

Construct it with the given TaQL expression.

Referenced by operator=(), and VirtualTaQLColumn().

## VirtualTaQLColumn() [2/3]

casacore::VirtualTaQLColumn::VirtualTaQLColumn | ( | const Record & | spec | ) |

Construct it with the given specification.

References casacore::Record().

## ~VirtualTaQLColumn()

virtual casacore::VirtualTaQLColumn::~VirtualTaQLColumn | ( |  | ) |

virtual

Destructor is mandatory.

## VirtualTaQLColumn() [3/3]

casacore::VirtualTaQLColumn::VirtualTaQLColumn | ( | const VirtualTaQLColumn & |  | ) |

delete

Copy is not needed and therefore forbidden.

References VirtualTaQLColumn().

## Member Function Documentation

## className()

String casacore::VirtualTaQLColumn::className | ( |  | ) |

static

Return the name of the class.

## clone()

virtual DataManager * casacore::VirtualTaQLColumn::clone | ( |  | ) | const

virtual

Clone the engine object.

Implements casacore::DataManager.

## create64()

virtual void casacore::VirtualTaQLColumn::create64 | ( | rownr_t |  | ) |

private virtual

Let the engine initialize the object for a new table.

It defines a column keyword holding the expression.

Reimplemented from casacore::VirtualColumnEngine.

## dataManagerSpec()

virtual Record casacore::VirtualTaQLColumn::dataManagerSpec | ( |  | ) | const

virtual

Get the data manager specification.

Reimplemented from casacore::DataManager.

References casacore::Record().

## dataManagerType()

virtual String casacore::VirtualTaQLColumn::dataManagerType | ( |  | ) | const

virtual

Return the type name of the engine.

(i.e. its class name VirtualTaQLColumn).

Implements casacore::DataManager.

## dataType()

virtual int casacore::VirtualTaQLColumn::dataType | ( |  | ) | const

virtual

Functions to return column info.

Implements casacore::DataManagerColumn.

Referenced by makeIndArrColumn(), and makeScalarColumn().

## expression()

const String & casacore::VirtualTaQLColumn::expression | ( |  | ) | const

inline

Return the TaQL expression used.

Definition at line 141 of file VirtualTaQLColumn.h.

References itsExpr.

## fillArray()

void casacore::VirtualTaQLColumn::fillArray | ( | ArrayBase & | data | ) |

private

Fill an array with a constant scalar value.

## fillColumnCache()

void casacore::VirtualTaQLColumn::fillColumnCache | ( |  | ) |

private

Fill the ColumnCache object with a constant scalar value.

## getArrayV()

virtual void casacore::VirtualTaQLColumn::getArrayV | ( | rownr_t | rownr,
|  | ArrayBase & | arr )

private virtual

Get the array value in the given row.

The array given by arr has to have the correct shape (which is guaranteed by the ArrayColumn get function).

Reimplemented from casacore::DataManagerColumn.

## getBool()

virtual void casacore::VirtualTaQLColumn::getBool | ( | rownr_t | rownr,
|  | Bool * | dataPtr )

private virtual

Get the scalar value in the given row.

Reimplemented from casacore::DataManagerColumn.

## getComplex()

virtual void casacore::VirtualTaQLColumn::getComplex | ( | rownr_t | rownr,
|  | Complex * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getDComplex()

virtual void casacore::VirtualTaQLColumn::getDComplex | ( | rownr_t | rownr,
|  | DComplex * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getdouble()

virtual void casacore::VirtualTaQLColumn::getdouble | ( | rownr_t | rownr,
|  | double * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getfloat()

virtual void casacore::VirtualTaQLColumn::getfloat | ( | rownr_t | rownr,
|  | float * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getInt()

virtual void casacore::VirtualTaQLColumn::getInt | ( | rownr_t | rownr,
|  | Int * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getInt64()

virtual void casacore::VirtualTaQLColumn::getInt64 | ( | rownr_t | rownr,
|  | Int64 * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getResult()

void casacore::VirtualTaQLColumn::getResult | ( | rownr_t | rownr | ) |

private

Get the array result into itsCurArray.

## getScalarColumnCellsV()

virtual void casacore::VirtualTaQLColumn::getScalarColumnCellsV | ( | const RefRows & | rownrs,
|  | ArrayBase & | dataPtr )

private virtual

Get some scalar values in the column.

The vector given in data has to have the correct length (which is guaranteed by the ScalarColumn getColumn function). The default implementation does a getXX per row.

Reimplemented from casacore::DataManagerColumn.

## getScalarColumnV()

virtual void casacore::VirtualTaQLColumn::getScalarColumnV | ( | ArrayBase & | arr | ) |

private virtual

Get functions implemented by means of their DataManagerColumn::getXXBase counterparts, but optimized for constant expressions.

Reimplemented from casacore::DataManagerColumn.

## getShort()

virtual void casacore::VirtualTaQLColumn::getShort | ( | rownr_t | rownr,
|  | Short * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getString()

virtual void casacore::VirtualTaQLColumn::getString | ( | rownr_t | rownr,
|  | String * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getuChar()

virtual void casacore::VirtualTaQLColumn::getuChar | ( | rownr_t | rownr,
|  | uChar * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getuInt()

virtual void casacore::VirtualTaQLColumn::getuInt | ( | rownr_t | rownr,
|  | uInt * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## getuShort()

virtual void casacore::VirtualTaQLColumn::getuShort | ( | rownr_t | rownr,
|  | uShort * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

## isShapeDefined()

virtual Bool casacore::VirtualTaQLColumn::isShapeDefined | ( | rownr_t | rownr | ) |

virtual

Is the value shape defined in the given row?

By default it returns True.

Reimplemented from casacore::DataManagerColumn.

## isWritable()

virtual Bool casacore::VirtualTaQLColumn::isWritable | ( |  | ) | const

virtual

Test if data can be put into this column.

This does not test if the data file is writable, only if it is in principle allowed to store data into the column. (It may not be allowed for virtual columns). The default is True.

Reimplemented from casacore::DataManagerColumn.

## makeCurArray()

void casacore::VirtualTaQLColumn::makeCurArray | ( |  | ) |

private

Make the result cache.

## makeIndArrColumn()

virtual DataManagerColumn * casacore::VirtualTaQLColumn::makeIndArrColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeId )

private virtual

Create the column object for the indirect array column in this engine.

Reimplemented from casacore::VirtualColumnEngine.

References casacore::DataManagerColumn::columnName(), casacore::DataManagerColumn::DataManagerColumn(), dataType(), and casacore::DataManagerColumn::dataTypeId().

## makeObject()

DataManager * casacore::VirtualTaQLColumn::makeObject | ( | const String & | dataManagerName,
|  | const Record & | spec )

static

Define the "constructor" to construct this engine when a table is read back.

This "constructor" has to be registered by the user of the engine. If the engine is commonly used, its registration can be added into the registerAllCtor function in DataManReg.cc. This function gets automatically invoked by the table system.

References casacore::DataManager::dataManagerName(), and casacore::Record().

## makeScalarColumn()

virtual DataManagerColumn * casacore::VirtualTaQLColumn::makeScalarColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | )

private virtual

Create the column object for the scalar column in this engine.

Reimplemented from casacore::VirtualColumnEngine.

References casacore::DataManagerColumn::columnName(), casacore::DataManagerColumn::DataManagerColumn(), and dataType().

## ndim()

virtual uInt casacore::VirtualTaQLColumn::ndim | ( | rownr_t | rownr | ) |

virtual

Get the dimensionality of the item in the given row.

By default it returns shape(rownr).nelements().

Reimplemented from casacore::DataManagerColumn.

## operator=()

VirtualTaQLColumn & casacore::VirtualTaQLColumn::operator= | ( | const VirtualTaQLColumn & |  | ) |

delete

Assignment is not needed and therefore forbidden.

References VirtualTaQLColumn().

## prepare()

virtual void casacore::VirtualTaQLColumn::prepare | ( |  | ) |

private virtual

Prepare compiles the expression.

Reimplemented from casacore::VirtualColumnEngine.

## registerClass()

void casacore::VirtualTaQLColumn::registerClass | ( |  | ) |

static

Register the class name and the static makeObject "constructor".

This will make the engine known to the table system.

## setMaxLength()

virtual void casacore::VirtualTaQLColumn::setMaxLength | ( | uInt | maxLength | ) |

virtual

Set the maximum length of a 'fixed length' string.

It is only called (right after the constructor) if the string has a fixed length.

Reimplemented from casacore::DataManagerColumn.

## setShapeColumn()

virtual void casacore::VirtualTaQLColumn::setShapeColumn | ( | const IPosition & | aShape | ) |

virtual

Set the shape of an array in the column.

It is only called (right after the constructor) if the array has a fixed shape.

Reimplemented from casacore::DataManagerColumn.

## shape()

virtual IPosition casacore::VirtualTaQLColumn::shape | ( | rownr_t | rownr | ) |

virtual

Get the shape of the item in the given row.

By default it returns a zero-length IPosition (for a scalar value).

Reimplemented from casacore::DataManagerColumn.

## Member Data Documentation

## [union]

union { ... } casacore::VirtualTaQLColumn

## itsBool

Bool casacore::VirtualTaQLColumn::itsBool

Definition at line 233 of file VirtualTaQLColumn.h.

## itsColumnName

String casacore::VirtualTaQLColumn::itsColumnName

private

Definition at line 226 of file VirtualTaQLColumn.h.

## itsComplex

Complex casacore::VirtualTaQLColumn::itsComplex

private

Definition at line 243 of file VirtualTaQLColumn.h.

## itsCurArray

ArrayBase* casacore::VirtualTaQLColumn::itsCurArray

private

Definition at line 246 of file VirtualTaQLColumn.h.

## itsCurRow

rownr_t casacore::VirtualTaQLColumn::itsCurRow

private

Definition at line 247 of file VirtualTaQLColumn.h.

## itsDataType

int casacore::VirtualTaQLColumn::itsDataType

private

Definition at line 222 of file VirtualTaQLColumn.h.

## itsDComplex

DComplex casacore::VirtualTaQLColumn::itsDComplex

private

Definition at line 244 of file VirtualTaQLColumn.h.

## itsDouble

Double casacore::VirtualTaQLColumn::itsDouble

Definition at line 241 of file VirtualTaQLColumn.h.

## itsExpr

String casacore::VirtualTaQLColumn::itsExpr

private

Definition at line 227 of file VirtualTaQLColumn.h.

Referenced by expression().

## itsFloat

Float casacore::VirtualTaQLColumn::itsFloat

Definition at line 240 of file VirtualTaQLColumn.h.

## itsInt

Int casacore::VirtualTaQLColumn::itsInt

Definition at line 237 of file VirtualTaQLColumn.h.

## itsInt64

Int64 casacore::VirtualTaQLColumn::itsInt64

Definition at line 239 of file VirtualTaQLColumn.h.

## itsIsArray

Bool casacore::VirtualTaQLColumn::itsIsArray

private

Definition at line 223 of file VirtualTaQLColumn.h.

## itsIsConst

Bool casacore::VirtualTaQLColumn::itsIsConst

private

Definition at line 224 of file VirtualTaQLColumn.h.

## itsMaxLen

uInt casacore::VirtualTaQLColumn::itsMaxLen

private

Definition at line 231 of file VirtualTaQLColumn.h.

## itsNode

TableExprNode* casacore::VirtualTaQLColumn::itsNode

private

Definition at line 229 of file VirtualTaQLColumn.h.

## itsShape

IPosition casacore::VirtualTaQLColumn::itsShape

private

Definition at line 230 of file VirtualTaQLColumn.h.

## itsShort

Short casacore::VirtualTaQLColumn::itsShort

Definition at line 235 of file VirtualTaQLColumn.h.

## itsString

String casacore::VirtualTaQLColumn::itsString

private

Definition at line 245 of file VirtualTaQLColumn.h.

## itsStyle

String casacore::VirtualTaQLColumn::itsStyle

private

Definition at line 228 of file VirtualTaQLColumn.h.

## itsTempWritable

Bool casacore::VirtualTaQLColumn::itsTempWritable

private

Definition at line 225 of file VirtualTaQLColumn.h.

## itsuChar

uChar casacore::VirtualTaQLColumn::itsuChar

Definition at line 234 of file VirtualTaQLColumn.h.

## itsuInt

uInt casacore::VirtualTaQLColumn::itsuInt

Definition at line 238 of file VirtualTaQLColumn.h.

## itsuShort

uShort casacore::VirtualTaQLColumn::itsuShort

Definition at line 236 of file VirtualTaQLColumn.h.

The documentation for this class was generated from the following file:

- tables/DataMan/VirtualTaQLColumn.h